import 'package:fis_measure/interfaces/date_types/point.dart';
import 'package:fis_measure/interfaces/process/calculators/values.dart';
import 'package:flutter/rendering.dart';
import 'item.dart';

/// 测试项单次快照
abstract class IMeasureItemFeature {
  /// 关联测量项
  IMeasureItem get refItem;

  /// 点集合
  List<DPoint> get innerPoints;

  /// 是否活动
  bool get isActive;

  /// 样式配置
  FeatureStyle get featureStyle;

  /// 测量模式的名称
  String get measureModeName;

  /// 序号
  int get id;

  /// 计算结果列表
  List<ValueBase> get values;

  /// 结果值
  ValueBase? get value;

  /// 所在帧索引
  int? frameIndex;

  /// 所在图标识
  int? imageBelongSign;

  /// 绘制
  void paint(Canvas canvas, Size size);

  /// 检查是否可绘制
  bool checkCanPaint();

  /// 设置当前 zoom area 的归一化 Rect
  void setZoomRect(Rect? zoomRect);

  /// 灌注图 绘制
  void paintPerfusion(Canvas canvas, Size size);

  /// 设置URM 双幅图
  void setURMDualImages(bool? isURMDualImages);
}

/// 测试项单次快照样式配置
class FeatureStyle {
  FeatureStyle({this.showBriefAnnotation = false});

  /// 是否显示简短描述
  bool showBriefAnnotation;
}
