import 'package:fis_common/event/event_type.dart';

import 'pixel_space.dart';

abstract class IStandardLine {
  /// 参考线物理长度(cm)
  double get physicsLength;
  set physicsLength(double val);

  /// 参考线像素长度
  double get pixelLength;
  set pixelLength(double val);

  /// 当前像素距离尺
  PixelSpacing get currentPixelSpacing;
  set currentPixelSpacing(PixelSpacing val);

  /// 单位像素物理长度(cm)
  double get perPixelPhysicalLength;

  /// 像素距离尺变化事件
  late final FEventHandler<PixelSpacing?> pixelSpacingChanged;
}
