import 'package:fis_measure/interfaces/process/calculators/values.dart';
import 'package:fis_measure/process/calcuators/formulas/index.dart' as formulas;

import 'package:vid/us/vid_us_unit.dart';

import '../interfaces/obstetrics.dart';
import 'utils.dart';

class ObstetricsFormulasBase implements IObstetricsFormulas {
  @override
  UnitFloatValue gsMax(
      UnitFloatValue d1, UnitFloatValue d2, UnitFloatValue d3) {
    final value = formulas.ObstetricsFormulas.gsMax(
      d1.convert(VidUsUnit.cm),
      d2.convert(VidUsUnit.cm),
      d3.convert(VidUsUnit.cm),
    );
    return UnitFloatValue(value, VidUsUnit.cm);
  }

  @override
  UnitFloatValue gsMean(
      UnitFloatValue d1, UnitFloatValue d2, UnitFloatValue d3) {
    final value = formulas.ObstetricsFormulas.gsMean(
      d1.convert(VidUsUnit.cm),
      d2.convert(VidUsUnit.cm),
      d3.convert(VidUsUnit.cm),
    );
    return UnitFloatValue(value, VidUsUnit.cm);
  }
}
