import 'package:fis_measure/interfaces/process/items/item.dart';
import 'package:fis_measure/interfaces/process/items/item_metas.dart';
import 'package:fis_measure/process/items/top_item_feature.dart';
import 'package:fis_measure/process/primitives/combos/urm_sr_roi_rect_combo.dart';
import 'package:fis_measure/process/primitives/urm_measure/urm_rect_measure.dart';

class URMTwoSRRoiRect extends URMTwoSRRoiRectAbstract<URMVelFeature> {
  static const String _area1Key = "Roi1";
  static const String _area2Key = "Roi2";

  late final URMRectMeasure a1;
  late final URMRectMeasure a2;

  URMTwoSRRoiRect(ItemMeta meta) : super(meta) {
    final metaA1 = meta.getChildByName(_area1Key)!;
    final metaA2 = meta.getChildByName(_area2Key)!;
    a1 = URMRectMeasure.createMeasureRect(metaA1, this);
    a2 = URMRectMeasure.createMeasureRect(metaA2, this);
    childItems.add(a1);
    childItems.add(a2);
  }

  @override
  URMRectMeasure get child1 => a1;

  @override
  URMRectMeasure get child2 => a2;

  @override
  URMVelFeature buildFeature() => URMVelFeature(this);

  @override
  void onCancelingOnce() {}

  static URMTwoSRRoiRect crateURMTwoSRRoiRect(ItemMeta meta,
      [IMeasureItem? parent]) {
    var urmVel = URMTwoSRRoiRect(meta);
    // urmVel.calculator = URMSrDensityCal(urmVel);

    return urmVel;
  }
}

class URMVelFeature extends TopMeasureItemFeature {
  URMVelFeature(
    ITopMeasureItem refItem,
  ) : super(refItem);
}
