import 'package:fis_measure/interfaces/enums/items.dart';
import 'package:fis_measure/interfaces/process/items/item.dart';
import 'package:fis_measure/interfaces/process/items/item_metas.dart';
import 'package:fis_measure/interfaces/process/workspace/point_info.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_curve_curvature_line.dart';
import 'package:fis_measure/process/primitives/trace.dart';
import 'package:fis_measure/utils/prompt_box.dart';

class URMCurveCurvatureLineMeasure extends Trace {
  URMCurveCurvatureLineMeasure(ItemMeta meta, IMeasureItem? parent)
      : super(meta, parent);

  static URMCurveCurvatureLineMeasure createURMCurveCurvatureLineMeasure(
      ItemMeta meta,
      [IMeasureItem? parent]) {
    URMCurveCurvatureLineMeasure trace =
        URMCurveCurvatureLineMeasure(meta, parent);
    trace.calculator = URMCurveCurvatureLineCal(trace);
    trace.isClosed = false;
    return trace;
  }

  @override
  bool onExecuteMouse(PointInfo args) {
    if (waitingResult) return false;
    if (state == ItemStates.finished) {
      if (args.pointType == PointInfoType.mouseDown) {
        state = ItemStates.waiting;
      }
    }

    if (state == ItemStates.waiting) {
      if (args.pointType == PointInfoType.mouseDown) {
        handleMouseDownWhileWaiting(args);
      }
    } else if (state == ItemStates.running) {
      if (args.pointType == PointInfoType.mouseUp) return false;

      feature?.adopt(args);
      if (args.pointType == PointInfoType.mouseDown) {
        handleFinish();
      } else {
        checkAutoSnap(args);
      }
    }
    return true;
  }

  bool waitingResult = false;

  void handleFinish() async {
    feature!.isActive = false;
    waitingResult = true;
    await doCalculateAsync();
    doFeatureFinish();
    PromptBox.dismiss();
    waitingResult = false;
  }
}
