import 'package:fis_measure/define.dart';
import 'package:fis_measure/view/ai_result_modifier/controller.dart';
import 'package:fis_measure/view/ai_result_modifier/widgets/ai_feature_analysis.dart';
import 'package:fis_ui/base_define/page.dart';
import 'package:fis_ui/index.dart';
import 'package:flutter/material.dart';

import 'ai_diagnostic_result.dart';

class AiConclusionResult extends FStatelessWidget implements FPage {
  const AiConclusionResult({Key? key}) : super(key: key);
  @override
  String get pageName => 'AiConclusionResult';

  @override
  FWidget build(BuildContext context) {
    return FisBuilder<AiResultModifierController>(
      id: 'ai_conclusion_result',
      builder: (_) {
        return FColumn(
          children: [
            AiDiagnosticResult(
              _.aiDetectedObjectList[_.currentAiDetectedObjectIndex],
              _.diagnosisOrgan,
            ),
            const FSizedBox(
              height: 15,
            ),
            FExpanded(
              child: AiFeatureAnalysis(
                _.aiDetectedObjectList[_.currentAiDetectedObjectIndex]
                    .descriptions,
              ),
            ),
          ],
        );
      },
    );
  }
}
