import 'package:fis_measure/interfaces/process/calculators/output.dart';
import 'package:fis_measure/interfaces/process/items/item_feature.dart';
import 'package:fis_measure/view/result/converter.dart';

class MeasureResult {
  final String measureApplicationName;
  final List<IMeasureItemFeature> features;
  MeasureResult({
    required this.measureApplicationName,
    required this.features,
  });
  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['MeasureApplicationName'] = measureApplicationName;
    map['Features'] = features;
    return map;
  }

  String toDisplay() {
    List<String> results = [];
    final idLength = features.length.toString().length;
    for (var feature in features) {
      final resultList = FeatureValueDescConverter(feature).generate(idLength);
      final strList = resultList.map((e) => e.toString()).toList();
      results.addAll(strList);
    }
    final resultString = '$measureApplicationName \n${results.join("\n")}';
    return resultString;
  }
}
