part of 'operate_bar.dart';

class _SharpnessCarotidToneBar extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => _SharpnessCarotidToneBarState();
}

class _SharpnessCarotidToneBarState extends State<_SharpnessCarotidToneBar> {
  final measure3DViewController = Get.find<Measure3DViewController>();

  double curValue = 0;
  @override
  void initState() {
    WidgetsBinding.instance.addPostFrameCallback((timeStamp) {
      if (mounted) {
        measure3DViewController.onResetTone.addListener(onResetTone);
      }
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return _ToneBar(
      max: 100,
      min: -100,
      value: curValue,
      icon: const Icon(
        Icons.change_history,
        color: Colors.white,
      ),
      onChange: (v) {
        utils.throttle(() {
          measure3DViewController.sharpness = v.toInt();
          measure3DViewController.notifyShellSetTone();
          setState(() {
            curValue = v;
          });
        }, 'onChangeSharpness', 50);
      },
    );
  }

  @override
  void dispose() {
    measure3DViewController.onResetTone.removeListener(onResetTone);
    super.dispose();
  }

  void onResetTone(Object sender, e) {
    setState(() {
      curValue = 0;
    });
  }
}

class _ContrastCarotidToneBar extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => _ContrastCarotidToneBarState();
}

class _ContrastCarotidToneBarState extends State<_ContrastCarotidToneBar> {
  final measure3DViewController = Get.find<Measure3DViewController>();

  double curValue = 0;
  @override
  void initState() {
    WidgetsBinding.instance.addPostFrameCallback((timeStamp) {
      if (mounted) {
        measure3DViewController.onResetTone.addListener(onResetTone);
      }
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return _ToneBar(
      max: 100,
      min: -100,
      value: curValue,
      icon: const Icon(
        Icons.contrast,
        color: Colors.white,
      ),
      onChange: (v) {
        utils.throttle(() {
          measure3DViewController.contrast = v.toInt();
          measure3DViewController.notifyShellSetTone();
          setState(() {
            curValue = v;
          });
        }, 'onChangeContrast', 50);
      },
    );
  }

  @override
  void dispose() {
    measure3DViewController.onResetTone.removeListener(onResetTone);
    super.dispose();
  }

  void onResetTone(Object sender, e) {
    setState(() {
      curValue = 0;
    });
  }
}

class _BrightnessCarotidToneBar extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => _BrightnessCarotidToneBarState();
}

class _BrightnessCarotidToneBarState extends State<_BrightnessCarotidToneBar> {
  final measure3DViewController = Get.find<Measure3DViewController>();

  double curValue = 0;
  @override
  void initState() {
    WidgetsBinding.instance.addPostFrameCallback((timeStamp) {
      if (mounted) {
        measure3DViewController.onResetTone.addListener(onResetTone);
      }
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return _ToneBar(
      max: 100,
      min: -100,
      value: curValue,
      icon: const Icon(
        Icons.wb_sunny_sharp,
        color: Colors.white,
      ),
      onChange: (v) {
        utils.throttle(() {
          measure3DViewController.brightness = v.toInt();
          measure3DViewController.notifyShellSetTone();
          setState(() {
            curValue = v;
          });
        }, 'onChangeBrightness', 50);
      },
    );
  }

  @override
  void dispose() {
    measure3DViewController.onResetTone.removeListener(onResetTone);
    super.dispose();
  }

  void onResetTone(Object sender, e) {
    setState(() {
      curValue = 0;
    });
  }
}

class _ResetCarotidToneButton extends StatelessWidget {
  final measure3DViewController = Get.find<Measure3DViewController>();

  @override
  Widget build(BuildContext context) {
    return ElevatedButton(
      onPressed: measure3DViewController.resetTone,
      child: Text(
        i18nBook.measure.resetTone4Btn.t,
        style: const TextStyle(color: Colors.white),
      ),
    );
  }
}
